/**
 *
 *  このソースはLive2D関連アプリの開発用途に限り
 *  自由に改変してご利用頂けます。
 *
 *  (c) CYBERNOIDS Co.,Ltd. All rights reserved.
 */
package jp.cybernoids.live2d
{
	import jp.live2d.ALive2DModel;
	import jp.live2d.param.ParamDefFloat;
	import jp.live2d.util.UtSystem;
	

	public class L2DBaseModel
	{
		protected var mainMotionManager:L2DMotionManager; //メインモーション
		protected var expressionManager:L2DMotionManager; //表情
		protected var eyeBlink:L2DEyeBlink; //自動目パチ
		protected var physics:L2DPhysics; //物理演算
		protected var pose:L2DPose; //ポーズ。腕の切り替えなど。
		
		//モーション
		protected var expressions:Array /*of AMotion*/; //表情
		protected var motions:Array /*of AMotion*/; //あらかじめ読み込んでおくモーション
		
		protected var modelMatrix:L2DModelMatrix;
		
		//状態
		protected var _initialized:Boolean = false; //初期化状態
		protected var _updating:Boolean = false; //読み込み中ならtrue
		protected var _alpha:Number = 1;
		protected var accAlpha:Number = 0;
		protected var lipSync:Boolean = false; //リップシンクが有効かどうか
		protected var lipSyncValue:Number; //基本は0～1
		
		
		
		//パラメータ
		protected var PARAM_ANGLE_X:String = "PARAM_ANGLE_X";
		protected var PARAM_ANGLE_Y:String = "PARAM_ANGLE_Y";
		protected var PARAM_ANGLE_Z:String = "PARAM_ANGLE_Z";
		protected var PARAM_BODY_X:String = "PARAM_BODY_X";
		protected var PARAM_BREATH:String = "PARAM_BREATH";
		protected var PARAM_EYE_BALL_X:String = "PARAM_EYE_BALL_X";
		protected var PARAM_EYE_BALL_Y:String = "PARAM_EYE_BALL_Y";
		protected var PARAM_MOUTH_OPEN_Y:String = "PARAM_MOUTH_OPEN_Y";
		
		protected var dragX:Number = 0;
		protected var dragY:Number = 0;
		
		protected var startTimeMSec:Number = 0;
		
		
		public function L2DBaseModel()
		{
			//モーションマネージャーを作成
			mainMotionManager = new L2DMotionManager(); //MotionQueueManagerクラスからの継承なので、使い方は同一
			expressionManager = new L2DMotionManager();
			motions = new Array();
			expressions = new Array();
			startTimeMSec = UtSystem.getUserTimeMSec();
		}
		
		
		
		
		public function setDrag(x:Number, y:Number):void
		{
			dragX = x;
			dragY = y;
		}
		
		
		public function getModelMatrix():L2DModelMatrix
		{
			return modelMatrix;
		}
		
		
		public function get alpha():Number
		{
			return _alpha;
		}
		
		
		public function set alpha(value:Number):void
		{
			_alpha = value;
		}
		
		
		public function get initialized():Boolean
		{
			return _initialized;
		}
		
		
		public function set initialized(value:Boolean):void
		{
			_initialized = value;
		}
		
		
		public function get updating():Boolean
		{
			return _updating;
		}
		
		
		public function set updating(value:Boolean):void
		{
			_updating = value;
		}
		
		
		
	
	}
}